/* ----------------------------------------------------------------- *
 *      mew-mime.cmd  --- external method for OS/2 Mew
 *
 *        Copyright (C) 1996,1997  OKUNISHI Fujikazu
 *        Copyright (C) 1997       KONDO Hiroyasu
 *
 * Author: OKUNISHI Fujikazu <fuji0924@mbox.kyoto-inet.or.jp>
 *         KONDO Hiroyasu    <hirokon@homi.toyota.aichi.jp>
 *
 * Version:
 *     $Id: mew-mime.cmd,v0.9+ 1997/09/08 22:11 F.OKUNISHI Exp $
 * Requirement:
 *     VREXX2.ZIP : Visual REXX for Presentation Manager(IBMEWS,Freeware)
 * ----------------------------------------------------------------- */

  Trace Off; '@echo off'
	Call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
	Call SysLoadFuncs

  Parse Source . . this .
  cmdPath = Filespec('Drive',this)||Filespec('Path',this)
  this = Filespec('Name',this)
  this = Left(this, Length(this) -4)
  inifspec='.'this'rc'

/* ----------------------------------------------------------------- *
 *  parameter check		"mew-mime {C-T:} {target}"
 * ----------------------------------------------------------------- */
  Parse Arg ct target opt .
   If target='' Then
     Do
       Call EMSG(0 'no parameters.')
       Call VMSG(1 'usage:' this '{C-T:} {targetfile}')
     End
   ct=Translate(ct); target=Translate(target,'\','/')

/* ----------------------------------------------------------------- *
 *  initialize
 * ----------------------------------------------------------------- */
  env = 'OS2ENVIRONMENT'
  home = Translate(Value('HOME',,env),'\','/')
  savedir=Value('MEW_TMP_DIR',,env)
   If savedir='' Then savedir=Value('TMP',,env)
   If savedir='' Then savedir=Value('TEMP',,env)
   If savedir='' Then savedir='.'
  fname = Translate(SysTempFileName(savedir'\mew-????'),'\','/')
  initfile = home'\'inifspec
  If Stream(initfile,'C','Query Exist')=''
    Then initfile=cmdPath||inifspec
  If Stream(initfile,'C','Query Exist')=''
    Then Do
      Call VMSG(0 initfile 'not exists.')
      Signal SAVE
    End

/* ----------------------------------------------------------------- *
 *  get progname from initfile
 * ----------------------------------------------------------------- */
  /* SysFileSearch cannot understand EOL=LF (T_T) */
/*Call SysFileSearch ct,initfile,'def.'
 *If def.0 = 0 Then Signal SAVE
 */
   Do While Lines(initfile)
      def = Translate(Linein(initfile),'',D2C(9))  /*TAB=>[white space]*/
      If Translate(Word(def,1)) = ct Then
        Do
          Parse Var def mtype suffix progname args
          If ct = Translate(mtype) Then Signal EXEC
        End
   End

/* ----------------------------------------------------------------- *
 *  undefined C-T: ==> treated as `Application/Octet-stream'
 * ----------------------------------------------------------------- */
SAVE:
	Call EMSG(0 'undefined C-T: in' initfile)
	fname = fname || '.bin'
	'copy' target fname '1>nul'
	If rc <> 0 Then Call VMSG(1 'cannot save as' fname)
	           Else Call VMSG(1 'saved as' fname)


/* ----------------------------------------------------------------- *
 *  exec extprog
 * ----------------------------------------------------------------- */
EXEC:
	Call LineOut(initfile)  /*close*/
	/* -------------------------------------------------------- *
	 *  CTE: x-uue	  `begin 644 foo.gif'
	 * -------------------------------------------------------- */
	head = Linein(target)
	Call Lineout target  /*close*/
	If Translate(Word(head,1))='BEGIN' & Datatype(Word(head,2),'W')=1
	  Then Do
	    uufname = Word(head,3)
	    'call uumerge -d' savedir target
	    If rc<>0 Then VMSG(1 'uumerge error!')
	             Else fname=savedir'\'uufname
	  End
	  Else Do
	    fname = fname || '.' || suffix
	    'copy' target fname '>nul'
	  End

	progname = Translate(progname,'\','/')
	args = Space(args)
		'detach' progname args fname
		Call SysSleep 2
		rc=SysFileDelete(fname)
Exit rc

/* ----------------------------------------------------------------- *
 *  error messages
 * ----------------------------------------------------------------- */
EMSG: Procedure
	Parse Arg act msg
	Call LineOut STDERR,msg
	If act=1 Then Exit
	Return

/* ----------------------------------------------------------------- *
 *  error dialog  (with VREXX.DLL)
 * ----------------------------------------------------------------- */
VMSG: Procedure  Expose this
	Parse Arg act msg
	Call RxFuncAdd 'VInit', 'VREXX', 'VINIT'
	initcode = VInit()
	If initcode ='ERROR' Then Do; Call VExit; Exit 255; End
	mbox.0=1; mbox.1=msg
	Call VmsgBox this, mbox, 1
	Call VExit
	If act=1 Then Exit
	Return

/* end of mew-mime.cmd */
